// Copyright (C) 2022 RozK
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _RK_ENGINE_RENDER_CONTEXT_H
#define _RK_ENGINE_RENDER_CONTEXT_H

#include "../render.hpp"
#include <GL/glx.h>

extern PFNGLDRAWELEMENTSINSTANCEDBASEINSTANCEPROC rk_DrawElementsInstancedBaseInstance;
extern PFNGLMULTIDRAWELEMENTSINDIRECTPROC rk_MultiDrawElementsIndirect;

RK_EXPORT rk_window_t rk_create_context(
    char const * name,
    rk_uint width,
    rk_uint height);

RK_EXPORT char ** rk_load_shader_source(
    char const * filename,
    rk_uint * length);

RK_EXPORT void rk_free_shader_source(
    char ** shader,
    rk_uint length);

RK_EXPORT void rk_swap_buffers();
RK_EXPORT void rk_destroy_context();

#endif // _RK_ENGINE_RENDER_CONTEXT_H
